=== debian/changelog ===
tetragon (0.10.0-0parrot1) lory; urgency=medium

  * Rebuild for Parrot 6.0.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Fri, 08 Sep 2023 17:31:27 +0200

tetragon (0.10.0-0kali1) kali-dev; urgency=medium

  * Fix debian/watch
  * New upstream version 0.10.0

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 18 Jul 2023 12:03:01 +0200

tetragon (0.9.0-0kali3) kali-dev; urgency=medium

  * Drop armel and armhf as they aren't supported.
  * ci: Drop 32bit arm architectures as they aren't supported.
  * Add lintian overrides
  * Prepare for Release

 -- Steev Klimaszewski <steev@kali.org>  Thu, 13 Apr 2023 01:02:31 -0500

tetragon (0.9.0-0kali2) kali-dev; urgency=medium

  * Package is not available on i386

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 05 Apr 2023 16:54:10 +0200

tetragon (0.9.0-0kali1) kali-dev; urgency=medium

  * Add GitLab's CI configuration file
  * Configure git-buildpackage for Kali
  * New upstream version 0.9.0

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 05 Apr 2023 15:38:08 +0200

tetragon (0.8.4-0kali1) kali-dev; urgency=medium

  * Initial release.

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 30 Mar 2023 15:24:53 +0200
