=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
export GOCACHE=$(CURDIR)/_build
export GOPATH=$(CURDIR)/_build
export GOPROXY=off


%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=bash-completion

override_dh_auto_build:
	go build ./cmd/tetra/

override_dh_auto_install:
	dh_auto_install -- --no-source

	# generate completion files
	$(CURDIR)/tetra completion bash >$(CURDIR)/debian/tetra.bash
	$(CURDIR)/tetra completion zsh >$(CURDIR)/debian/_tetra

override_dh_installdocs:
	dh_installdocs
	# add missing NOTICE files when license is Apache 2
	mkdir -p debian/tetragon/usr/share/doc/tetragon/grpc
	cp api/vendor/google.golang.org/grpc/NOTICE.txt debian/tetragon/usr/share/doc/tetragon/grpc
	mkdir -p debian/tetragon/usr/share/doc/tetragon/yaml.v2
	cp api/vendor/gopkg.in/yaml.v2/NOTICE debian/tetragon/usr/share/doc/tetragon/yaml.v2
	mkdir -p debian/tetragon/usr/share/doc/tetragon/yaml.v3
	cp api/vendor/gopkg.in/yaml.v3/NOTICE debian/tetragon/usr/share/doc/tetragon/yaml.v3
	mkdir -p debian/tetragon/usr/share/doc/tetragon/prometheus
	cp vendor/github.com/prometheus/client_golang/NOTICE debian/tetragon/usr/share/doc/tetragon/prometheus

override_dh_auto_test:

override_dh_dwz:
