=== debian/watch ===
version=4
opts="uversionmangle=s/-[a-z]*/~/, \
      filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
    https://github.com/cilium/tetragon/tags \
    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
