## tetragon 1.1.0

=== DESCRIPTION ===
Package: tetragon
Type: Package
Title: Automatic Sequence Prediction by Expansion of the Distance
        Matrix
Version: 1.1.0
Author: Giancarlo Vercellino
Maintainer: Giancarlo Vercellino <giancarlo.vercellino@gmail.com>
Description: Each sequence is predicted by expanding the distance matrix. The compact set of hyper-parameters is tuned through random search.
License: GPL-3
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.1.1
Depends: R (>= 4.1)
Imports: purrr (>= 0.3.4), abind (>= 1.4-5), ggplot2 (>= 3.3.5), readr
        (>= 2.0.1), stringr (>= 1.4.0), lubridate (>= 1.7.10), narray
        (>= 0.4.1.1), imputeTS (>= 3.2), scales (>= 1.1.1), tictoc (>=
        1.0.1), modeest (>= 2.4.0), moments (>= 0.14), greybox (>=
        1.0.1), philentropy (>= 0.5.0), dqrng (>= 0.3.0), entropy (>=
        1.3.1)
URL: https://rpubs.com/giancarlo_vercellino/tetragon
NeedsCompilation: no
Packaged: 2022-04-25 06:09:21 UTC; gvercellino
Repository: CRAN
Date/Publication: 2022-04-25 06:50:02 UTC
