## tetragon 1.3.0

=== DESCRIPTION ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Type: Package
 Title: Automatic Sequence Prediction by Expansion of the Distance
         Matrix
-Version: 1.2.0
+Version: 1.3.0
 Author: Giancarlo Vercellino
 Maintainer: Giancarlo Vercellino <giancarlo.vercellino@gmail.com>
 Description: Each sequence is predicted by expanding the distance matrix. The compact set of hyper-parameters is tuned through random search.
@@ -16,9 +16,10 @@
         (>= 0.4.1.1), imputeTS (>= 3.2), scales (>= 1.1.1), tictoc (>=
         1.0.1), modeest (>= 2.4.0), moments (>= 0.14), greybox (>=
         1.0.1), dqrng (>= 0.3.0), entropy (>= 1.3.1), Rfast (>= 2.0.6),
-        philentropy (>= 0.5.0)
+        philentropy (>= 0.5.0), fastDummies (>= 1.6.3), fANCOVA (>=
+        0.6-1)
 URL: https://rpubs.com/giancarlo_vercellino/tetragon
 NeedsCompilation: no
-Packaged: 2022-06-06 16:21:32 UTC; gvercellino
+Packaged: 2022-08-13 16:47:17 UTC; gvercellino
 Repository: CRAN
-Date/Publication: 2022-06-07 03:50:02 UTC
+Date/Publication: 2022-08-13 17:30:02 UTC
